%set_strip_skiplist */lib*-d-*.so.*
%define libsuffix 1_34_1
%define namesuffix 1_34_1
%ifarch %ix86
%define jamdir tools/jam/src/bin.linuxx86
%endif
%ifarch x86_64
%define jamdir tools/jam/src/bin.linux
%endif
%ifarch ppc
%define jamdir tools/jam/src/bin.linuxppc
%endif
%ifarch arm
%define jamdir tools/jam/src/bin.linuxarm
%endif

%set_verify_elf_method unresolved=relaxed

Name: libboost1.34.1
Version: 1.34.1
Release: alt3
Epoch:	1

Summary: Boost libraries
License: Boost Software License
Group: System/Legacy libraries
Url: http://www.boost.org

Packager: Ivan A. Melnikov <iv@altlinux.org>

Source: boost_%namesuffix.tar
Source1: regex-config.in
Source2: python-config.in
Source3: thread-config.in
Source4: signals-config.in
Patch0:	boost-1.31.0-make.patch
Patch1:	boost-1.32.0-alt-symlink.patch
Patch2: boost-regex-fix-r42674.patch

BuildPreReq: python-devel

# Automatically added by buildreq on Thu Aug 14 2003
BuildRequires: gcc-c++ libstdc++-devel zlib-devel bzlib-devel libicu-devel

%description
The Boost web site provides free peer-reviewed portable C++ source libraries.
The emphasis is on libraries which work well with the C++ Standard Library. One
goal is to establish "existing practice" and provide reference implementations
so that the Boost libraries are suitable for eventual standardization. Some of
the libraries have already been proposed for inclusion in the C++ Standards
Committee's upcoming C++ Standard Library Technical Report.
                          
Although Boost was begun by members of the C++ Standards Committee Library
Working Group, membership has expanded to include nearly two thousand members
of the C++ community at large.


%package datetime
Summary: Date-Time Library.
Group: System/Legacy libraries

%description datetime
Programming  with  dates  and  times  should  be  almost as simple and
natural  as  programming  with strings and integers. Applications with
lots  of temporal logic can be radically simplified by having a robust
set  of operators and calculation capabilities. Classes should provide
the ability to compare dates and times, add lengths or time durations,
retrieve dates and times from clocks, and work naturally with date and
time intervals.

%package filesystem
Summary: Filesystem Library
Group: System/Legacy libraries

%description filesystem
The Boost Filesystem Library provides portable facilities to query and
manipulate paths, files, and directories.

%package graph
Summary: Graph Library
Group: System/Legacy libraries

%description graph
The Boost Graph Library provides  graph components and algorithms.

%package iostreams
Summary: I/O streams Library
Group: System/Legacy libraries

%description iostreams
The Boost Iostreams Library provides various iostreams support


%package wave
Summary: Boost.Wave Library
Group: System/Legacy libraries

%description wave
The Boost Wave Library

%package test
Summary: Test Library
Group: System/Legacy libraries

%description test
The Boost Test Library provides a matched set of components for writing test
programs, organizing tests in to simple test cases and test suites, and
controlling their runtime execution. The Program Execution Monitor is also
useful in some production (non-test) environments. 


%package regex
Summary: Regular expressions library for C++
Group: System/Legacy libraries
Obsoletes: boost-regex-gcc2, boost-regex-gcc3
Provides: boost-regex-gcc2 = %epoch:%version-%release
Provides: boost-regex-gcc3 = %epoch:%version-%release

%description regex
Regular expressions are a form of pattern-matching that are often used in text
processing; many users will be familiar with the Unix utilities grep, sed and
awk, and the programming language perl, each of which make extensive use of
regular expressions. Traditionally C++ users have been limited to the POSIX C
API's for manipulating regular expressions, and while regex++ does provide
these API's, they do not represent the best way to use the library. For example
regex++ can cope with wide character strings, or search and replace operations
(in a manner analogous to either sed or perl), something that traditional C
libraries can not do.


%package python
Group: System/Legacy libraries
Summary: The Boost Python Library (Boost.Python)
Obsoletes: boost-python-gcc2, boost-python-gcc3
Provides: boost-python-gcc2 = %epoch:%version-%release
Provides: boost-python-gcc3 = %epoch:%version-%release

%description python
Use the Boost Python Library to quickly and easily export a C++ library to
Python such that the Python interface is very similar to the C++ interface. It
is designed to be minimally intrusive on your C++ design. In most cases, you
should not have to alter your C++ classes in any way in order to use them with
Boost.Python. The system should simply ``reflect'' your C++ classes and
functions into Python.


%package thread
Group: System/Legacy libraries
Summary: The Boost Threads Library (Boost.Threads)
Obsoletes: boost-thread-gcc2, boost-thread-gcc3
Provides: boost-thread-gcc2 = %epoch:%version-%release
Provides: boost-thread-gcc3 = %epoch:%version-%release

%description thread
Boost.Threads allows C++ programs to execute as multiple, asynchronous,
independent, threads-of-execution. Each thread has its own machine state
including program instruction counter and registers. Programs which execute as
multiple threads are called multi-threaded programs to distinguish them from
traditional single-threaded programs. Definitions gives a more complete
description of the multi-threading execution environment.


%package signals
Group: System/Legacy libraries
Summary: The Boost Signals Library (Boost.Signals)

%description signals
The  Boost.Signals  library  is an implementation of a managed signals and
slots  system. Signals represent callbacks with multiple targets, and  are
also called publishers or events in similar systems. Signals are connected to
some set of slots, which are callback receivers (also called event targets or
subscribers), which are called when the signal is "emitted."


%package program-options
Group: System/Legacy libraries
Summary: The Boost Program_options Library (Boost.Program_options)
Obsoletes: program_options
Provides: program_options = %epoch:%version-%release

%description program-options
The program_options library allows program developers to obtain program
options, that is (name, value) pairs from the user, via conventional methods
such as command line and config file.

%package serialization
Group: System/Legacy libraries
Summary: The Boost Serialization Library (Boost.Serialization)

%description serialization
Here, we use the term "serialization" to mean the reversible deconstruction of
an arbitrary set of C++ data structures to a sequence of bytes. Such a system
can be used to reconstitute an equivalent structure in another program context.
Depending on this context, this might used implement object persistence, remote
parameter passing or other facility.  In this system we use the term "archive"
to refer to a specific rendering of this stream of bytes. This could be a file
of binary data, text data, XML, or some other created by the user of this
library.


%prep 
%setup -q -n boost_%namesuffix
chmod u+w -R *
find ./ -type f -exec chmod a-x '{}' ';'
#patch0 -p1
#patch1 -p1
%patch2 -p2

sed -i 's/\$(LN)/$(LN) -s/' tools/build/v2/tools/common.jam

%build

chmod +x configure tools/jam/src/build.sh
./configure --prefix=%_prefix --libdir=%_libdir --includedir=%_includedir
%make_build

%install
mkdir -p $RPM_BUILD_ROOT%_bindir
mkdir -p $RPM_BUILD_ROOT%_includedir
mkdir -p $RPM_BUILD_ROOT%_libdir

%make_install PREFIX=%buildroot%_prefix EPREFIX=%buildroot%_prefix LIBDIR=%buildroot%_libdir INCLUDEDIR=%buildroot%_includedir  install

rm -rf %buildroot%_includedir/boost-%libsuffix

#remove symlinks in %%_libdir
for f in $RPM_BUILD_ROOT/%_libdir/*; do
	if test -L $f; then
		rm -f $f
	fi
done

#remove static libraries if any
rm %buildroot%_libdir/*.a ||:


%files regex
%_libdir/libboost_regex-gcc41-%libsuffix.so.*
%_libdir/libboost_regex-gcc41-mt-%libsuffix.so.*

%files python
%_libdir/libboost_python-gcc41-%libsuffix.so.*
%_libdir/libboost_python-gcc41-mt-%libsuffix.so.*

%files thread
%_libdir/libboost_thread-gcc41-mt-%libsuffix.so.*

%files graph
%_libdir/libboost_graph-gcc41-%libsuffix.so.*
%_libdir/libboost_graph-gcc41-mt-%libsuffix.so.*

%files signals
%_libdir/libboost_signals-gcc41-%libsuffix.so.*
%_libdir/libboost_signals-gcc41-mt-%libsuffix.so.*

%files datetime
%_libdir/libboost_date_time-gcc41-%libsuffix.so.*
%_libdir/libboost_date_time-gcc41-mt-%libsuffix.so.*

%files filesystem
%_libdir/libboost_filesystem-gcc41-%libsuffix.so.*
%_libdir/libboost_filesystem-gcc41-mt-%libsuffix.so.*

%files iostreams
%_libdir/libboost_iostreams-gcc41-%libsuffix.so.*
%_libdir/libboost_iostreams-gcc41-mt-%libsuffix.so.*

%files test
%_libdir/libboost_prg_exec_monitor-gcc41-%libsuffix.so.*
%_libdir/libboost_prg_exec_monitor-gcc41-mt-%libsuffix.so.*
#_libdir/libboost_test_exec_monitor-gcc41-%libsuffix.so.*
#_libdir/libboost_test_exec_monitor-gcc41-mt-%libsuffix.so.*
%_libdir/libboost_unit_test_framework-gcc41-%libsuffix.so.*
%_libdir/libboost_unit_test_framework-gcc41-mt-%libsuffix.so.*

%files program-options
%_libdir/libboost_program_options-gcc41-%libsuffix.so.*
%_libdir/libboost_program_options-gcc41-mt-%libsuffix.so.*

%files serialization
%_libdir/libboost_serialization-gcc41-%libsuffix.so.*
%_libdir/libboost_wserialization-gcc41-%libsuffix.so.*
%_libdir/libboost_serialization-gcc41-mt-%libsuffix.so.*
%_libdir/libboost_wserialization-gcc41-mt-%libsuffix.so.*

%files wave
%_libdir/libboost_wave-gcc41-%libsuffix.so.*
%_libdir/libboost_wave-gcc41-mt-%libsuffix.so.*

%post regex -p /sbin/ldconfig
%postun regex -p /sbin/ldconfig

%post python -p /sbin/ldconfig
%postun python -p /sbin/ldconfig

%post thread -p /sbin/ldconfig
%postun thread -p /sbin/ldconfig

%post signals -p /sbin/ldconfig
%postun signals -p /sbin/ldconfig

%post datetime -p /sbin/ldconfig
%postun datetime -p /sbin/ldconfig

%post filesystem -p /sbin/ldconfig
%postun filesystem -p /sbin/ldconfig

%post iostreams -p /sbin/ldconfig
%postun iostreams -p /sbin/ldconfig

%post serialization -p /sbin/ldconfig
%postun serialization -p /sbin/ldconfig

%post test -p /sbin/ldconfig
%postun test -p /sbin/ldconfig

%post program-options -p /sbin/ldconfig
%postun program-options -p /sbin/ldconfig

%changelog
* Mon Sep 29 2008 Ivan A. Melnikov <iv@altlinux.org> 1:1.34.1-alt3
- Removed specifications for development packages
- Changed group of all remained packages to System/Legacy libraries

* Mon Sep 15 2008 Ivan A. Melnikov <iv@altlinux.org> 1:1.34.1-alt2
- Cleaned up unneeded files and actions

* Mon Sep 15 2008 Ivan A. Melnikov <iv@altlinux.org> 1:1.34.1-alt1
- Built 1.34.1 in compatibility mode (no devel)

* Sun Sep 07 2008 Damir Shayhutdinov <damir@altlinux.ru> 1:1.34.1-alt2
- Fix #15421, #15397, #17004 and build on ppc platform

* Sun Mar 23 2008 Damir Shayhutdinov <damir@altlinux.ru> 1:1.34.1-alt1
- New version

* Tue Feb 05 2008 Damir Shayhutdinov <damir@altlinux.ru> 1:1.34.0-alt5.1
- Applied bga@'s patch for building with python2.5

* Sat Feb 02 2008 Grigory Batalov <bga@altlinux.ru> 1:1.34.0-alt5
- Build without exact python version

* Wed Jan 16 2008 Damir Shayhutdinov <damir@altlinux.ru> 1:1.34.0-alt4
- Fixed invalid memory access in boost-regex++ (thanks ldv@ for noticing)
  + CVE-2008-171
  + CVE-2008-172

* Sun Sep 09 2007 Damir Shayhutdinov <damir@altlinux.ru> 1:1.34.0-alt3
- Provide backward-compatibility symlinks for static libraries (libboost_foo.a->libboost_foo-gcc41-mt.a)

* Tue Jul 03 2007 Damir Shayhutdinov <damir@altlinux.ru> 1:1.34.0-alt2
- Use symlinks, not hardlinks for .so files
- Provide backward-compatibility symlinks for libraries (libboost_foo.so->libboost_foo-gcc41-mt.so)

* Mon May 14 2007 Damir Shayhutdinov <damir@altlinux.ru> 1:1.34.0-alt1
- New version
- New subpackage (graph)

* Sat Apr 07 2007 Damir Shayhutdinov <damir@altlinux.ru> 1:1.33.1-alt4
- boost-devel now requires boost-serialization-devel (#11298)

* Mon Jan 08 2007 Damir Shayhutdinov <damir@altlinux.ru> 1:1.33.1-alt3
- Added missing dependancy for boost-program-options-devel (#10578) 

* Fri Dec 22 2006 Damir Shayhutdinov <damir@altlinux.ru> 1:1.33.1-alt2
- Added missing dependancy for boost-serialization-devel (#10485)

* Thu Sep 14 2006 Damir Shayhutdinov <damir@altlinux.ru> 1:1.33.1-alt1
- New version
- New subpackage (iostreams)

* Mon Apr 25 2005 Anton D. Kachalov <mouse@altlinux.org> 1:1.32.0-alt2
- rebuild with python 2.4
- x86_64 support

* Mon Jan 17 2005 Alexey Voinov <voins@altlinux.ru> 1:1.32.0-alt1
- new version (1.32.0)
- program-options* subpackages added
- serialization subpackage added

* Mon May 24 2004 Alexey Voinov <voins@altlinux.ru> 1:1.31.0-alt2
- builddep on python-devel is now versioned

* Thu Apr 22 2004 Alexey Voinov <voins@altlinux.ru> 1:1.31.0-alt1
- new version (1.31.0)
- license changed to Boost Software License
- Reqs on boost-devel changed to PreReqs to enforce order of installation
- lots of triggers added to provide smooth upgrade

* Mon Aug 25 2003 Alexey Voinov <voins@altlinux.ru> 1:1.30.2-alt1
- new version (1.30.2)

* Wed Aug 13 2003 Alexey Voinov <voins@altlinux.ru> 1:1.30.0-alt1
- new version (1.30.0)
- build system changed, so %%build section does
- added subpackages for datetime, filesystem and test libraries
- description for signals library added
- epoch added (all .so's uses %version as so-version, regex library
  should be updated)
- removed all subpackage specific versions

* Tue Jan 21 2003 Alexey Voinov <voins@voins.program.ru> 1.29.0-alt1
- new version (1.29.0) now we know about g++-3.2
- fixes bug #0001863
- docs added
- new subpackage -signals- added
- boost-threads-devel-static temporarily removed, because static
  libraries for it is not built with boost build system.

* Tue Sep 10 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.4
- fixed version numbere for gcc-3.2. 
(this is temporary release)

* Mon Aug 19 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.3
- ...-config scripts renamed (s/_/-/g)
- added macros to control compilers version for which to build library

* Sun Aug 18 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.2
- spec rewrite: subpackages rearranged, files rearranged
- use gcc-version specific directories instead of update-alternatives
- remake patch updated (soname added)
- pytmake patch updated (soname fixed)
- buildreqs fixed

* Mon Jun 10 2002 Alexey Voinov <voins@voins.program.ru> 1.28.0-alt0.1
- new version (1.28.0)
- .makefile patch split into .remake and .pytmake patches
- buildreqs fixed

* Thu Jun 06 2002 Alexey Voinov <voins@voins.program.ru> 1.27.0-alt0.2
- gcc2/gcc3 variants added for regex subpackages
- /usr/bin/*_config files added
- python subpackages added
- buildreqs fixed
